Difference between revisions of "Part Module"

From FreeCAD Documentation
Jump to navigation Jump to search
m (png to svg)
 
(23 intermediate revisions by 6 users not shown)
Line 9: Line 9:
 
}}
 
}}
  
 +
<!--T:66-->
 +
[[Image:Workbench_Part.svg|thumb|128px|Part workbench icon]]
 
</translate>
 
</translate>
[[Image:Workbench_Part.svg|240px|center]]
+
{{TOCright}}
 
<translate>
 
<translate>
<!--T:66-->
 
{{Caption|align=center|The FreeCAD Part Workbench Icon}}
 
 
 
== Introduction == <!--T:1-->
 
== Introduction == <!--T:1-->
The solid modelling capabilities of FreeCAD are based on the [http://en.wikipedia.org/wiki/Open_Cascade_Technology Open Cascade Technology] (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation. The [[Part Workbench|Part Workbench]] is a layer sitting on top of the OCCT libraries, that gives the user access to OCCT geometric primitives and functions. Essentially all 2D and 3D drawing functions in every workbench ([[Draft Workbench|Draft]], [[Sketcher Workbench|Sketcher]], [[PartDesign Workbench|PartDesign]], etc.), are based on these functions exposed by the Part Workbench. Therefore, the Part Workbench is considered the core component of the modelling capabilities of FreeCAD.
+
The solid modelling capabilities of FreeCAD are based on the [http://en.wikipedia.org/wiki/Open_Cascade_Technology Open Cascade Technology] (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation. The [[Image:Workbench_Part.svg|24px]] [[Part Workbench|Part Workbench]] is a layer sitting on top of the OCCT libraries, that gives the user access to OCCT geometric primitives and functions. Essentially all 2D and 3D drawing functions in every workbench ([[Image:Workbench_Draft.svg|24px]] [[Draft Workbench|Draft]], [[Image:Workbench_Sketcher.svg|24px]] [[Sketcher Workbench|Sketcher]], [[Image:Workbench_PartDesign.svg|24px]] [[PartDesign Workbench|PartDesign]], etc.), are based on these functions exposed by the Part Workbench. Therefore, the Part Workbench is considered the core component of the modelling capabilities of FreeCAD.
  
 
<!--T:35-->
 
<!--T:35-->
The objects created with the Part Workbench are relatively simple; they are intended to be used with boolean operations (unions and cuts) in order to build more complex shapes. This modelling paradigm is known as the [[constructive solid geometry]] (CSG) workflow, and it was the traditional methodology used in early CAD systems. On the other hand, the [[PartDesign Workbench|PartDesign Workbench]] provides a more modern workflow to constructing shapes: it uses a parametrically defined sketch, that is extruded to form a basic solid body, which is then modified by parametric transformations ([[feature editing|feature editing]]), until the final object is obtained.
+
The objects created with the Part Workbench are relatively simple; they are intended to be used with boolean operations (unions and cuts) in order to build more complex shapes. '''This modeling paradigm is known as the [[constructive solid geometry]] (CSG) workflow, and it was the traditional methodology used in early CAD systems.''' On the other hand, the [[PartDesign Workbench|PartDesign Workbench]] provides a more modern workflow to constructing shapes: it uses a parametrically defined sketch, that is extruded to form a basic solid body, which is then modified by parametric transformations ([[feature editing|feature editing]]), until the final object is obtained.
  
 
<!--T:54-->
 
<!--T:54-->
Line 25: Line 24:
  
 
</translate>
 
</translate>
{{TOCright}}
 
[[Image:Part example.jpg]]
 
 
 
[[Image:Part_Workbench_relationships.svg|600px]]
 
[[Image:Part_Workbench_relationships.svg|600px]]
 
<translate>
 
<translate>
Line 50: Line 46:
 
* [[Image:Part_Cone.svg|32px]] [[Part_Cone|Cone]]: Draws a cone by specifying its dimensions
 
* [[Image:Part_Cone.svg|32px]] [[Part_Cone|Cone]]: Draws a cone by specifying its dimensions
 
* [[Image:Part_Torus.svg|32px]] [[Part_Torus|Torus]]: Draws a torus (ring) by specifying its dimensions
 
* [[Image:Part_Torus.svg|32px]] [[Part_Torus|Torus]]: Draws a torus (ring) by specifying its dimensions
* [[Image:Part_CreatePrimitives.svg|32px]] [[Part_CreatePrimitives|CreatePrimitives]]: A tool to create various parametric geometric primitives
+
* [[Image:Part_Primitives.svg|32px]] [[Part_Primitives|Primitives]]: A tool to add any of the defined geometric primitives.
* [[Image:Part_Shapebuilder.svg|32px]] [[Part_Shapebuilder|Shapebuilder]]: A tool to create more complex shapes from various parametric geometric primitives
+
* [[Image:Part_Shapebuilder.svg|32px]] [[Part_Builder|Shapebuilder]]: A tool to create more complex shapes from various parametric geometric primitives
  
 
===Modifying objects=== <!--T:38-->
 
===Modifying objects=== <!--T:38-->
Line 80: Line 76:
  
 
<!--T:47-->
 
<!--T:47-->
* [[Image:Part_CompCompoundTools.png|48px]] [[Part_CompCompoundTools|Compound Tools]]:
+
* [[Image:Part_Compound.svg|48px]] [[Part_CompCompoundTools|Compound Tools]]:
** [[Image:Part MakeCompound.png|32px]] [[Part MakeCompound|Make compound]]: Creates a compound from the selected objects.
+
** [[Image:Part_Compound.svg|32px]] [[Part_Compound|Make compound]]: Creates a compound from the selected objects.
 
** [[Image:Part_ExplodeCompound.svg|32px]] [[Part_ExplodeCompound|Explode Compound]]: Tool to split up compounds of shapes
 
** [[Image:Part_ExplodeCompound.svg|32px]] [[Part_ExplodeCompound|Explode Compound]]: Tool to split up compounds of shapes
 
** [[Image:Part Compound‏‎Filter.svg|32px]] [[Part Compound‏‎Filter|Compound Filter]]: The CompoundFilter can be used to extract the individual pieces.
 
** [[Image:Part Compound‏‎Filter.svg|32px]] [[Part Compound‏‎Filter|Compound Filter]]: The CompoundFilter can be used to extract the individual pieces.
  
 
<!--T:48-->
 
<!--T:48-->
* [[Image:Part_Booleans.svg|32px]] [[Part_Booleans|Booleans]]: Performs boolean operations on objects
+
* [[Image:Part_Booleans.svg|32px]] [[Part_Boolean|Boolean]]: Performs boolean operations on objects
* [[Image:Part_Union.png|32px]] [[Part_Union|Union]]: Fuses (unions) two objects
+
* [[Image:Part_Fuse.svg|32px]] [[Part_Union|Union]]: Fuses (unions) two objects
* [[Image:Part_Common.png|32px]] [[Part_Common|Common]]: Extracts the common (intersection) part of two objects
+
* [[Image:Part_Common.svg|32px]] [[Part_Common|Common]]: Extracts the common (intersection) part of two objects
* [[Image:Part_Cut.png|32px]] [[Part_Cut|Cut]]: Cuts (subtracts) one object from another
+
* [[Image:Part_Cut.svg|32px]] [[Part_Cut|Cut]]: Cuts (subtracts) one object from another
  
 
<!--T:49-->
 
<!--T:49-->
 
* [[Image:Part_CompJoinFeatures.png|48px]] [[Part CompJoinFeatures|Join features]]: smart booleans for walled objects (e.g., pipes) {{Version|0.16}}
 
* [[Image:Part_CompJoinFeatures.png|48px]] [[Part CompJoinFeatures|Join features]]: smart booleans for walled objects (e.g., pipes) {{Version|0.16}}
** [[Image:Part JoinConnect.png|32px]] [[Part_JoinConnect|Connect]]: Connects interiors of objects {{Version|0.16}}
+
** [[Image:Part_JoinConnect.svg|32px]] [[Part_JoinConnect|Connect]]: Connects interiors of objects {{Version|0.16}}
** [[Image:Part JoinEmbed.png|32px]] [[Part_JoinEmbed|Embed]]: Embeds a walled object into another walled object {{Version|0.16}}
+
** [[Image:Part_JoinEmbed.svg|32px]] [[Part_JoinEmbed|Embed]]: Embeds a walled object into another walled object {{Version|0.16}}
** [[Image:Part JoinCutout.png|32px]] [[Part_JoinCutout|Cutout]]: Creates a cutout in a wall of an object for another walled object {{Version|0.16}}
+
** [[Image:Part_JoinCutout.svg|32px]] [[Part_JoinCutout|Cutout]]: Creates a cutout in a wall of an object for another walled object {{Version|0.16}}
  
 
<!--T:50-->
 
<!--T:50-->
Line 107: Line 103:
 
* [[Image:Part Defeaturing.svg|32px]] [[Part_Defeaturing|Defeaturing]]: {{Version|0.18}}
 
* [[Image:Part Defeaturing.svg|32px]] [[Part_Defeaturing|Defeaturing]]: {{Version|0.18}}
 
* [[Image:Part_Section.svg|32px]] [[Part_Section|Section]]: Creates a section by intersecting an object with a section plane
 
* [[Image:Part_Section.svg|32px]] [[Part_Section|Section]]: Creates a section by intersecting an object with a section plane
* [[Image:Part_SectionCross.png|32px]] [[Part_SectionCross|Cross sections...]]:
+
* [[Image:Part_CrossSections.svg|32px]] [[Part_SectionCross|Cross sections...]]: Creates one or more cross-sections through a selected shape
 
* [[Image:Part Attachment.svg|32px]] [[Part Attachment|Attachment]]: attachment is a utility to attach an object to another one.
 
* [[Image:Part Attachment.svg|32px]] [[Part Attachment|Attachment]]: attachment is a utility to attach an object to another one.
  
Line 156: Line 152:
  
 
<!--T:13-->
 
<!--T:13-->
In summary, geometry primitives are "shapeless" building blocks, while topological shapes are the real objects built on them.
+
In summary, geometry primitives are "shapeless" building blocks, while [[Part_TopoShape|topological shapes]] are the real objects built on them.
  
 
<!--T:14-->
 
<!--T:14-->
Line 175: Line 171:
  
 
<!--T:65-->
 
<!--T:65-->
{{Caption|The "Part::TopoShape" is the geometrical object that is seen on screen. Essentially all workbenches use these TopoShapes internally to build and display edges, faces, and solids.}}
+
{{Caption|The {{incode|Part::TopoShape}} class is the geometrical object that is seen on screen. Essentially all workbenches use these [[Part_TopoShape|TopoShapes]] internally to build and display edges, faces, and solids.}}
  
 
== Scripting == <!--T:18-->
 
== Scripting == <!--T:18-->
Line 191: Line 187:
 
<!--T:64-->
 
<!--T:64-->
 
Another simple object used in 2D geometrical objects is [[Part Part2DObject|Part Part2DObject]], which is the base of [[Sketcher_SketchObject|Sketcher SketchObject]] ([[Sketcher Workbench|Sketcher]]), and most [[Draft Workbench|Draft elements]].
 
Another simple object used in 2D geometrical objects is [[Part Part2DObject|Part Part2DObject]], which is the base of [[Sketcher_SketchObject|Sketcher SketchObject]] ([[Sketcher Workbench|Sketcher]]), and most [[Draft Workbench|Draft elements]].
 +
 +
=== Test script === <!--T:69-->
 +
 +
<!--T:70-->
 +
Test the creation of [[Part_Primitives|Part Primitives]] with a script. {{Version|0.19}}
 +
 +
</translate>
 +
{{Code|code=
 +
import parttests.part_test_objects as pto
 +
pto.create_test_file("example_file")
 +
}}
 +
<translate>
 +
 +
<!--T:71-->
 +
This script is located in the installation directory of the program, and can be examined to see how the basic primitives are built.
 +
</translate>
 +
{{Code|code=
 +
$INSTALL_DIR/Mod/Part/parttests/part_test_objects.py
 +
}}
 +
<translate>
  
 
=== Examples === <!--T:20-->
 
=== Examples === <!--T:20-->
Line 253: Line 269:
 
<!--T:27-->
 
<!--T:27-->
 
Note that a Line Segment can be created by specifying its start and endpoint directly in the constructor, for example Part.LineSegment(point1,point2), or we can create a default line and set its properties afterwards, as we did here.
 
Note that a Line Segment can be created by specifying its start and endpoint directly in the constructor, for example Part.LineSegment(point1,point2), or we can create a default line and set its properties afterwards, as we did here.
 +
 +
<!--T:72-->
 +
A Line can be created also using:
 +
 +
</translate>
 +
{{Code|code=
 +
import FreeCAD
 +
import Part
 +
DOC = FreeCAD.newDocument()
 +
 +
def mycreateLine(pt1, pt2, objName):
 +
    obj = DOC.addObject("Part::Line", objName)
 +
    obj.X1 = pt1[0]
 +
    obj.Y1 = pt1[2]
 +
    obj.Z1 = pt1[2]
 +
 +
    obj.X2 = pt2[0]
 +
    obj.Y2 = pt2[1]
 +
    obj.Z2 = pt2[2]
 +
 +
    DOC.recompute()
 +
    return obj
 +
 +
line = mycreateLine((0,0,0), (0,10,0), "LineName")
 +
 +
}}
 +
 +
<translate>
 +
  
 
<!--T:28-->
 
<!--T:28-->
Line 267: Line 312:
 
doc.recompute()
 
doc.recompute()
 
}}
 
}}
 +
<translate>
 +
 +
<!--T:73-->
 +
or using:
 +
 +
</translate>
 +
{{Code|code=
 +
import FreeCAD
 +
import Part
 +
DOC = FreeCAD.newDocument()
 +
 +
def mycreateCircle(rad, objName):
 +
    obj = DOC.addObject("Part::Circle", objName)
 +
    obj.Radius = rad
 +
 +
    DOC.recompute()
 +
    return obj
 +
 +
circle = mycreateCircle(5.0, "CircleName")
 +
 +
}}
 +
 
<translate>
 
<translate>
  
Line 299: Line 366:
 
}}
 
}}
  
<!--T:53-->
 
{{Userdocnavi}}
 
  
<!--T:67-->
+
</translate>
{{Part Tools navi}}
 
  
<!--T:68-->
+
{{Userdocnavi{{#translation:}}}}
[[Category:Workbenches]]
 
  
 +
{{Part Tools navi{{#translation:}}}}
  
</translate>
+
[[Category:Workbenches{{#translation:}}]]

Latest revision as of 20:39, 26 March 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎hrvatski • ‎italiano • ‎polski • ‎português • ‎português do Brasil • ‎română • ‎svenska • ‎čeština • ‎русский • ‎українська • ‎中文 • ‎中文(中国大陆)‎ • ‎中文(台灣)‎ • ‎日本語
Part workbench icon

Introduction

The solid modelling capabilities of FreeCAD are based on the Open Cascade Technology (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation. The Workbench Part.svg Part Workbench is a layer sitting on top of the OCCT libraries, that gives the user access to OCCT geometric primitives and functions. Essentially all 2D and 3D drawing functions in every workbench (Workbench Draft.svg Draft, Workbench Sketcher.svg Sketcher, Workbench PartDesign.svg PartDesign, etc.), are based on these functions exposed by the Part Workbench. Therefore, the Part Workbench is considered the core component of the modelling capabilities of FreeCAD.

The objects created with the Part Workbench are relatively simple; they are intended to be used with boolean operations (unions and cuts) in order to build more complex shapes. This modeling paradigm is known as the constructive solid geometry (CSG) workflow, and it was the traditional methodology used in early CAD systems. On the other hand, the PartDesign Workbench provides a more modern workflow to constructing shapes: it uses a parametrically defined sketch, that is extruded to form a basic solid body, which is then modified by parametric transformations (feature editing), until the final object is obtained.

Part objects are more complex than mesh objects created with the Mesh Workbench, as they permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.

Part Workbench relationships.svg

The Part Workbench is the basic layer that exposes the OCCT drawing functions to all workbenches in FreeCAD


Tools

The tools are all located in the Part menu.

Primitives

These are tools for creating primitive objects.

  • Part Box.svg Box: Draws a box by specifying its dimensions
  • Part Cylinder.svg Cylinder: Draws a cylinder by specifying its dimensions
  • Part Sphere.svg Sphere: Draws a sphere by specifying its dimensions
  • Part Cone.svg Cone: Draws a cone by specifying its dimensions
  • Part Torus.svg Torus: Draws a torus (ring) by specifying its dimensions
  • Part Primitives.svg Primitives: A tool to add any of the defined geometric primitives.
  • Part Shapebuilder.svg Shapebuilder: A tool to create more complex shapes from various parametric geometric primitives

Modifying objects

These are tools for modifying existing objects. They will allow you to choose which object to modify.

  • Part Extrude.svg Extrude: Extrudes planar faces of an object
  • Part Revolve.svg Revolve: Creates a solid by revolving another object (not solid) around an axis
  • Part Mirror.svg Mirror: Mirrors the selected object on a given mirror plane
  • Part Fillet.svg Fillet: Fillets (rounds) edges of an object
  • Part Chamfer.svg Chamfer: Chamfers edges of an object
  • Part RuledSurface.svg Ruled Surface:
  • Part Loft.svg Loft: Lofts from one profile to another
  • Part Sweep.svg Sweep: Sweeps one or more profiles along a path
  • Part Thickness.svg Thickness: Hollows out a solid, leaving openings next to select faces.
  • Part Booleans.svg Boolean: Performs boolean operations on objects
  • Part Fuse.svg Union: Fuses (unions) two objects
  • Part Common.svg Common: Extracts the common (intersection) part of two objects
  • Part Cut.svg Cut: Cuts (subtracts) one object from another

Measure

Std Measure Menu.png Measure: Allows linear and angular measurement between points, edges, and faces.

Other tools

Preferences

OCCT geometric concepts

In OpenCascade terminology, we distinguish between geometric primitives and topological shapes. A geometric primitive can be a point, a line, a circle, a plane, etc. or even some more complex types like a B-Spline curve or a surface. A shape can be a vertex, an edge, a wire, a face, a solid or a compound of other shapes. The geometric primitives are not made to be directly displayed on the 3D scene, but rather to be used as building geometry for shapes. For example, an edge can be constructed from a line or from a portion of a circle.

In summary, geometry primitives are "shapeless" building blocks, while topological shapes are the real objects built on them.

A complete list of all primitives and shapes refer to the OCC documentation (Alternative: sourcearchive.com) and search for Geom_* (for geometric primitives) and TopoDS_* (for shapes). There you can also read more about the differences between them. Please note that the official OCC documentation is not available online (you must download an archive) and is mostly aimed at programmers, not at end-users. But hopefully you'll find enough information to get started here.

The geometric types actually can be divided into two major groups: curves and surfaces. Out of the curves (line, circle, ...) you can directly build an edge, out of the surfaces (plane, cylinder, ...) a face can be built. For example, the geometric primitive line is unlimited, i.e. it is defined by a base vector and a direction vector while its shape representation must be something limited by a start and end point. And a box -- a solid -- can be created by six limited planes.

From an edge or face you can also go back to its geometric primitive counterpart.

Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shapes a more complex shape is made of.

Part TopoShape relationships.svg

The Part::TopoShape class is the geometrical object that is seen on screen. Essentially all workbenches use these TopoShapes internally to build and display edges, faces, and solids.


Scripting

See also: Part scripting

The main data structure used in the Part module is the BRep data type from OpenCascade. Almost all contents and object types of the Part module are available by Python scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creation methods exist, and for some of them, especially the TopoShapes, advanced operations like boolean union/difference/intersection are also available. Explore the contents of the Part module, as described in the FreeCAD Scripting Basics page, to know more.

The most basic object that can be created is a Part Feature, which has a simple DataPlacement property, and basic properties to define its color and appearance.

Another simple object used in 2D geometrical objects is Part Part2DObject, which is the base of Sketcher SketchObject (Sketcher), and most Draft elements.

Test script

Test the creation of Part Primitives with a script. introduced in version 0.19

import parttests.part_test_objects as pto
pto.create_test_file("example_file")

This script is located in the installation directory of the program, and can be examined to see how the basic primitives are built.

$INSTALL_DIR/Mod/Part/parttests/part_test_objects.py

Examples

To create a line element switch to the Python console and type in:

import Part,PartGui 
doc=App.newDocument()  
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Let's go through the above python example step by step:

import Part,PartGui
doc=App.newDocument()

loads the Part module and creates a new document

l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

Line is actually a line segment, hence the start and endpoint.

doc.addObject("Part::Feature","Line").Shape=l.toShape()

This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.LineSegment) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.

doc.recompute()

Updates the document. This also prepares the visual representation of the new part object.

Note that a Line Segment can be created by specifying its start and endpoint directly in the constructor, for example Part.LineSegment(point1,point2), or we can create a default line and set its properties afterwards, as we did here.

A Line can be created also using:

import FreeCAD
import Part
DOC = FreeCAD.newDocument()

def mycreateLine(pt1, pt2, objName):
    obj = DOC.addObject("Part::Line", objName)
    obj.X1 = pt1[0]
    obj.Y1 = pt1[2]
    obj.Z1 = pt1[2]

    obj.X2 = pt2[0]
    obj.Y2 = pt2[1]
    obj.Z2 = pt2[2]

    DOC.recompute()
    return obj

line = mycreateLine((0,0,0), (0,10,0), "LineName")


A circle can be created in a similar way:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

or using:

import FreeCAD
import Part
DOC = FreeCAD.newDocument()

def mycreateCircle(rad, objName):
    obj = DOC.addObject("Part::Circle", objName)
    obj.Radius = rad

    DOC.recompute()
    return obj

circle = mycreateCircle(5.0, "CircleName")


Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:

s = f.Shape
e = s.Edges[0]
c = e.Curve

Here we take the shape of our object f, then we take its list of edges. In this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.

Head to the Topological data scripting page if you would like to know more.

Tutorials